%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This file contains the main VAR code for the paper "The effects of oil price 
% uncertainty on global real economic activity."  by Soojin Jo
% This file mainly reproduced the sensitivity check results presented in
% the online Appendix
% July 2013. 

% add paths
%path(path,'C:\Jo2013\Code')
%path(path,'C:\Jo2013\Code\functions')
%path(path,'C:\Jo2013\Code\figures')
%path(path,'C:\Jo2013\Code\Data')
%path(path,'C:\Jo2013\Code\Appendix')
%path(path,'C:\Jo2013\Code\Variations')
path(path,'C:\Users\joso\Desktop\Jo2013')
path(path,'C:\Users\joso\Desktop\Jo2013\functions')
path(path,'C:\Users\joso\Desktop\Jo2013\figures')
path(path,'C:\Users\joso\Desktop\Jo2013\Data')
path(path,'C:\Users\joso\Desktop\Jo2013\Appendix')
path(path,'C:\Users\joso\Desktop\Jo2013\Variations')

%% Appendix 4-1 structural break
%% (A) dummy for 1984Q1 (Table A3)
clear all; close all; clc;
genRV;
setup_sb; % sets up
initialdraws;
GS_sb;
% Summary statistics in Table A3
meanL = mean(postL) 
stdL = std(postL)

%% (B) Split sample VARs (Table A4 & A5)
clear all; close all; clc;
stbreak = 0; % stbreak denotes the time period used to divide the sample into two. 
% Can choose an integer from 0 to 4 for breaks in 1984Q1, 1985Q1, 1986Q1, 1987Q1, and 1988Q1, respectively. 
genRV;
setup_sb2;
initialdraws_sb2;
GS_sb2;
% Summary statistics in Table A4 & A5
% meanL1 and stdL1 are statistics for the first subsample period, and meanL2 and
% stdL2 are those for the second subsample period.
meanL1 = mean(postL1) 
stdL1 = std(postL1)
meanL2 = mean(postL2) 
stdL2 = std(postL2)

%% Appendix 4-2 advanced economies
clear all; close all; clc;
genRV_ae;
setup_ae;
initialdraws;
GS_benchmark;
% Summary statistics in Table A6 Column (1)
meanL = mean(postL) 
stdL = std(postL)
% Summary statistics in Table A6 Column (2)
GS_woRV;
meanLwoRV = mean(postLwoRV) 
stdLwoRV = std(postLwoRV)
%% Appendix 4-3 changes in oil price series
clear all; close all; clc;
genRV;
setup_op;
initialdraws;
GS_benchmark;
% Summary statistics in Table A7 Column (1)
meanL = mean(postL) 
stdL = std(postL)
% Summary statistics in Table A7 Column (2)
GS_woRV;
meanLwoRV = mean(postLwoRV) 
stdLwoRV = std(postLwoRV)
% Summary statistics in Table A7 Column (3)
clear all; close all; clc;
genRV_ae;
setup_op_ae;
initialdraws;
GS_benchmark;
meanL = mean(postL) 
stdL = std(postL)
% Summary statistics in Table A7 Column (4)
GS_woRV;
meanLwoRV = mean(postLwoRV) 
stdLwoRV = std(postLwoRV)

%% Appendix 4-5 Measurement error of the RV estimator
clear all; close all; clc;
genRV;
setup_benchmark;
initialdraws; % sets up initial draws
GS_me;
% Summary statistics in Table A8
meanM = mean(postPP) 
stdM = std(postPP)