%% Figure6
sOP=sort(IRF_uOP,1);
sOQ=sort(IRF_uOQ,1);
sY=sort(IRF_uY,1);
sV=sort(IRF_uVol,1);
s05=round(NG*0.05);
s95=round(NG*0.95);

sV50=(sV(NG*0.5,:)+sV(NG*0.5+1,:))./2;
sV05 = sV(s05,:);
sV95 = sV(s95,:);

%sP50 = median(sOP,3);
sP50 = (sOP(NG*0.5,:)+sOP(NG*0.5+1,:))./2;
sP05 = sOP(s05,:);
sP95 = sOP(s95,:);

%sQ50 = median(sOQ, 3);
sQ50 = (sOQ(NG*0.5,:)+sOQ(NG*0.5+1,:))./2;
sQ05 = sOQ(s05,:);
sQ95 = sOQ(s95,:);

%sY50 = median(sY, 3);
sY50 = (sY(NG*0.5,:)+sY(NG*0.5+1,:))./2;
sY05 = sY(s05,:);
sY95 = sY(s95,:);
%
HO=0:1:12;

figure('Name', 'Impulse responses to a 100% uncertainty shock') 
subplot(2,2,1)
plot(HO,sV50,'LineWidth',2)
hold on
[fillhandle1,msg1]=jbfill(HO,sV05,sV95,'b','k',1,0.3);
grid on
title('Oil price uncertainty')
subplot(2,2,2)
plot(HO,sP50,'LineWidth',2)
hold on
[fillhandle1,msg1]=jbfill(HO,sP05,sP95,'b','k',1,0.3);
grid on
ylabel('Percentage point')
title('Real price of oil')
subplot(2,2,3)
plot(HO,sQ50,'LineWidth',2)
hold on
[fillhandle2,msg2]=jbfill(HO,sQ05,sQ95,'b','k',1,0.3);
grid on
ylabel('Percentage point')
title('World oil production')
subplot(2,2,4)
plot(HO,sY50,'LineWidth',2)
hold on
[fillhandle3,msg3]=jbfill(HO,sY05,sY95,'b','k',1,0.3);
grid on
ylabel('Percentage point')
title('World industrial production')