%% IRFtoUncertainty (comment18)
sOP=sort(IRF_uOP,1);
sOQ=sort(IRF_uOQ,1);
sY=sort(IRF_uY,1);
sV=sort(IRF_uVol,1);
s16=round(NG*0.05);
s84=round(NG*0.95);

sV50=(sV(NG*0.5,:)+sV(NG*0.5+1,:))./2;
sV16 = sV(s16,:);
sV84 = sV(s84,:);

%sP50 = median(sOP,3);
sP50 = (sOP(NG*0.5,:)+sOP(NG*0.5+1,:))./2;
sP16 = sOP(s16,:);
sP84 = sOP(s84,:);

%sQ50 = median(sOQ, 3);
sQ50 = (sOQ(NG*0.5,:)+sOQ(NG*0.5+1,:))./2;
sQ16 = sOQ(s16,:);
sQ84 = sOQ(s84,:);

%sY50 = median(sY, 3);
sY50 = (sY(NG*0.5,:)+sY(NG*0.5+1,:))./2;
sY16 = sY(s16,:);
sY84 = sY(s84,:);
%
HO=[1985.75:0.25:(1985.75+0.25*12)];

figure('Name', 'Cumulative effects of oil price volatility during the 1986 oil price collapse') 
subplot(2,2,1)
plot(HO,sV50,'LineWidth',2)
hold on
[fillhandle1,msg1]=jbfill(HO,sV05,sV95,'b','k',1,0.3);
set(gca, 'XTick', 1960:0.5:1988.5)
set(gca, 'XTickLabel',{'1986Q1','1986Q3','1987Q1','1987Q3','1988Q1','1988Q3'})
grid on
title('Oil price uncertainty')
subplot(2,2,2)
plot(HO,sP50,'LineWidth',2)
hold on
[fillhandle1,msg1]=jbfill(HO,sP05,sP95,'b','k',1,0.3);
set(gca, 'XTick', 1960:0.5:1988.5)
set(gca, 'XTickLabel',{'1986Q1','1986Q3','1987Q1','1987Q3','1988Q1','1988Q3'})
grid on
ylabel('Percentage point')
title('Real price of oil')
subplot(2,2,3)
plot(HO,sQ50,'LineWidth',2)
hold on
[fillhandle2,msg2]=jbfill(HO,sQ05,sQ95,'b','k',1,0.3);
set(gca, 'XTick', 1960:0.5:1988.5)
set(gca, 'XTickLabel',{'1986Q1','1986Q3','1987Q1','1987Q3','1988Q1','1988Q3'})
grid on
ylabel('Percentage point')
title('World oil production')
subplot(2,2,4)
plot(HO,sY50,'LineWidth',2)
hold on
[fillhandle3,msg3]=jbfill(HO,sY05,sY95,'b','k',1,0.3);
set(gca, 'XTick', 1960:0.5:1988.5)
set(gca, 'XTickLabel',{'1986Q1','1986Q3','1987Q1','1987Q3','1988Q1','1988Q3'})
grid on
ylabel('Percentage point')
title('World industrial production')