%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This code is to draw time-varying volatilities from the conditional
% distributions given as h | A, logIV, Sigma, Y which incorporates the
% information obtained from the high frequency data.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%% (1) Draw h_1t's first.%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ystar11 = e1(:,1).^2; 
% Following Primiceri (2005), transform to the log-scale 
% but also add the 'offset constant'=0.001 
yss11 = log(ystar11 + 0.001);

vart11 = zeros(T1,1);
ys11 = zeros(T1,1);
for i = 1:T1
     imix1 = statedraw1(i,1);
     vart11(i) = u2_s(imix1);
     ys11(i) = yss11(i) - m_s(imix1) + 1.2704;
end

% draw oil production uncertainty.
%lhdraw1 = mixednormalh(ys1',vart1,Wdraw(1,1),1,1,T,prior_logh(1),prior_varh(1,1),rho1);
F11 = [1 0; int11 rho11];
Q1=[zeros(1,2); 0 Wdraw1(1,1)];
lhdraw11 = kfh1([0 2]', Q1, F11, vart11, ys11,[0 prior_logh1(1)]',[zeros(1,2);0 prior_varh1(1,1)], 2);
 % Next draw state (chi square approximation mixture component) conditional on Sigtdraw
 % This is used to update at the next step the log-volatilities Sigtdraw
%
 for i = 1:T1
     for j = 1:numel(m_s)
            % temp1= (1/sqrt(2*pi*u2_s(j)))*exp(-.5*(((yss(i,jj) - lhdraw1(jj,i) - m_s(j) + 1.2704)^2)/u2_s(j)));
            temp11= (1/sqrt(2*pi*u2_s(j)))*exp(-.5*(((yss11(i) - 2*lhdraw11(i) - m_s(j) + 1.2704)^2)/u2_s(j)));
            prw1(j,1) = q_s(j,1)*temp11;
     end
     prw1 = prw1./sum(prw1);
     cprw1 = cumsum(prw1);
     trand = rand(1,1);
     if trand < cprw1(1,1), imix1=1;
     elseif trand < cprw1(2,1), imix1=2;
     elseif trand < cprw1(3,1), imix1=3;
     elseif trand < cprw1(4,1), imix1=4;
     elseif trand < cprw1(5,1), imix1=5;
     elseif trand < cprw1(6,1), imix1=6;
     else imix1=7; 
     end
            % statedraw T+1 * N matrix
     statedraw1(i,1)=imix1;  % this is a draw of the mixture component index
end
tempH1= zeros(3, T1);
tempH1(1,:) = lhdraw11;

%%%%%%%%%%%%%%%%%%%%%%%%%%% (2) Draw h_2t's. %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for t=1:T1
   U231(:,t) = AA11(3,:,t)*(Y11(:,t) - X11(:,:,t)'*Bdraw1) ;
end
ystar21 = e1(:,2).^2;
yss21 = log(ystar21(:,1) + 0.001);
vart211 = zeros(T1*2,2);
ys211 = zeros(T1,1); 
for i = 1:T1
     imix1 = statedraw1(i,2);
     vart211(2*(i-1)+1,1) = u2_s(imix1);
     vart211(2*(i-1)+2,2) = Hdraw1(3,i)^2;
     ys211(2*(i-1)+1) = yss21(i) - m_s(imix1) + 1.2704;
     ys211(2*i) = U231(i);
end
% Draw oil price uncertainty.
H1 = [2 Ldraw1];
%H2 = [2 Ldraw 2]; % (1*3) matrix
Qt = Wdraw1(2,2);
F2draw = rho21;
btt = prior_logh1(2); %h0|0
Vtt = prior_varh1(2,2); %P0|0

bt = zeros(T1,1);
bp = zeros(T1,1);
Vt = zeros(T1,1);
Vp = zeros(T1,1);

for i = 1:T1
    bpt = F2draw*btt; %h1|0
    Vpt = F2draw*Vtt*F2draw+Qt; %P1|0
    R = vart211((i-1)*2+1:i*2,:);  % vart2 := R , ys2 := obs.variable %(2*2)
    cfe = ys211((i-1)*2+1:i*2) - H1'*bpt; 
    f = H1'*Vpt*H1 + R; 
    inv_f = inv(f);
    
    btt = bpt + Vpt*H1*inv_f*cfe; %(1*1)
    Vtt = Vpt - Vpt*H1*inv_f*H1'*Vpt; %(1*1)

    bt(i) = btt;  % 1|1, 2|2, ....., T|T
    bp(i) = bpt;  % 1|0, 2|1, ..... T|T-1
    Vt(i) = Vtt;
    Vp(i) = Vpt;
end

lhdraw21 = zeros(T1,1);
lhdraw21(T1,:) = bt(T1) + chol(Vt(T1))'*randn(1,1);

% following Primiceri (2005), start backward recussion.

for i = 1:T1-1
    b = lhdraw21(T1-i+1,:);
    bb = bt(T1-i) + Vt(T1-i)*F2draw'*inv(Vp(T1-i+1))*(b-F2draw*bt(T1-i));
    Vb = Vt(T1-i) - Vt(T1-i)*F2draw'*inv(Vp(T1-i+1))*F2draw*Vt(T1-i);
    lhdraw21(T1-i) = bb + chol(Vb)'*randn(1,1);
end

lhdraw21 = lhdraw21';
tempH1(2,:) = lhdraw21;

for i = 1:T1
     for j = 1:numel(m_s)
            temp1= (1/sqrt(2*pi*u2_s(j)))*exp(-.5*(((yss21(i) - 2*lhdraw21(i) - m_s(j) + 1.2704)^2)/u2_s(j)));
            prw1(j,1) = q_s(j,1)*temp1;
     end
     prw1 = prw1./sum(prw1);
     cprw1 = cumsum(prw1);
     trand = rand(1,1);
     if trand < cprw1(1,1), imix1=1;
     elseif trand < cprw1(2,1), imix1=2;
     elseif trand < cprw1(3,1), imix1=3;
     elseif trand < cprw1(4,1), imix1=4;
     elseif trand < cprw1(5,1), imix1=5;
     elseif trand < cprw1(6,1), imix1=6;
     else imix1=7; 
     end
            % statedraw T+1 * N matrix
     statedraw1(i,2)=imix1;  % this is a draw of the mixture component index
end


%%%%%%%%%%%%%%%%%%%%%%%%%%% (3) Draw h_3t's. %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tempHH1 = genHH(tempH1', N, T1);
ystar31 = zeros(1,T1);
for t=1:T1
    ystar31(:,t) = (AA11(3,:,t)*(Y11(:,t) - X11(:,:,t)'*Bdraw1 -tempHH1(:,:,t)'*LL1))^2;
end
% Transform to the log-scale but also add the 'offset constant' 
 yss31 = log(ystar31' + 0.001);
 
 vart31 = zeros(T1,1);
 yss131 = zeros(T1,1);
    for i = 1:T1
            imix1 = statedraw1(i,3);
            vart31(i,:) = u2_s(imix1);
            yss131(i) = yss31(i) - m_s(imix1) + 1.2704;
    end

F11 = [1 0; int31 rho31];
Q1=[zeros(1,2); 0 Wdraw1(3,3)];
lhdraw31 = kfh1([0 2]', Q1, F11, vart31, yss131,[1 prior_logh1(3)]',[zeros(1,2);0 prior_varh1(3,3)], 2);
 
for i = 1:T1
    for j = 1:numel(m_s)
                temp1= (1/sqrt(2*pi*u2_s(j)))*exp(-.5*(((yss31(i) - 2*lhdraw31(i) - m_s(j) + 1.2704)^2)/u2_s(j)));
                prw1(j,1) = q_s(j,1)*temp1;
     end
            prw1 = prw1./sum(prw1);
            cprw1 = cumsum(prw1);
            trand = rand(1,1);
    if trand < cprw1(1,1); imix1=1;
    elseif trand < cprw1(2,1), imix1=2;
    elseif trand < cprw1(3,1), imix1=3;
    elseif trand < cprw1(4,1), imix1=4;
    elseif trand < cprw1(5,1), imix1=5;
    elseif trand < cprw1(6,1), imix1=6;
    else imix1=7; 
    end
    statedraw1(i,3)=imix1;  % this is a draw of the mixture component index
end

%%%%%%%%%%%%%%%%%%%%%% Put together the draws %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

lhdraw1 = [lhdraw11; lhdraw21; lhdraw31];
Hdraw1 = zeros(3,T1);
 for j = 1:N
     Hdraw1(j,:) = exp(lhdraw1(j,:));
 end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Draw W, the covariance of SIGMA(t) (from iWishart)
    % Get first differences of Sigtdraw to compute the SSE
    rd=repmat(rhodraw1',T1-1,1);
    intd=repmat(intdraw1',T1-1,1);
    Sigttemp = lhdraw1(:,2:end)' -intd - rd.*lhdraw1(:,1:end-1)';

    sse_2 = zeros(N,1);
    Wdraw1 = zeros(N,1);

    for ii=1:N
        %sse_2(ii) = Sigttemp(:,ii)'*Sigttemp(:,ii)+prior_QW(ii,ii);
        sse_2(ii) = Sigttemp(:,ii)'*Sigttemp(:,ii)+prior_QW1;
        %z = chol(inv(sse_2(ii)))'*randn(1,post_dfW);
        z = randn(post_dfW1,1);
        x = z'*z;
        Wdraw1(ii,ii) = sse_2(ii)/x;
    end
    
%%%%%%%%%%%  Draw F %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for ii=1:N
    Rxox1 = zeros(2,2);
    Rxoy1= zeros(2,1);
    yh1 = lhdraw1(ii,2:end)'; 
    xh1 = [ones(T1-1,1) lhdraw1(ii,1:end-1)']; 
    for t = 1:T1-1
        Rxox1 = Rxox1 + xh1(t,:)'*inv(Wdraw1(ii,ii))*xh1(t,:);
        Rxoy1 = Rxoy1 + xh1(t,:)'*inv(Wdraw1(ii,ii))*yh1(t);
    end
    %post_varrho = inv(inv(prior_varrho(ii,ii)) + xh'*inv(Wdraw(ii,ii))*xh);
    post_varrho1 = inv(inv(prior_varrho1)+Rxox1);
    post_meanrho1 = post_varrho1*(prior_varrho1\prior_meanrho1 + Rxoy1);
    %rhohat = xh'*inv(Wdraw(ii,ii))*yh;
    %post_meanrho = post_varrho*(rhohat+inv(prior_varrho(ii,ii))*prior_meanrho(ii));
    intrho1(ii,:) = (post_meanrho1 + chol(post_varrho1)'*randn(2,1))';
end
intdraw1 = intrho1(:,1);
rhodraw1 = intrho1(:,2);
int11 = intdraw1(1);
int21 = intdraw1(2);
int31 = intdraw1(3);
rho11 = rhodraw1(1);
rho21 = rhodraw1(2);
rho31 = rhodraw1(3);

%%%%%%%%%%%%%%%%%%%%%%%% (1) Draw h_1t's first.%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ystar12 = e2(:,1).^2; 
% Following Primiceri (2005), transform to the log-scale 
% but also add the 'offset constant'=0.001 
yss12 = log(ystar12 + 0.001);

vart12 = zeros(T2,1);
ys12 = zeros(T2,1);
for i = 1:T2
     imix2 = statedraw2(i,1);
     vart12(i) = u2_s(imix2);
     ys12(i) = yss12(i) - m_s(imix2) + 1.2704;
end

% draw oil production uncertainty.
%lhdraw1 = mixednormalh(ys1',vart1,Wdraw(1,1),1,1,T,prior_logh(1),prior_varh(1,1),rho1);
F22 = [1 0; int12 rho12];
Q2=[zeros(1,2); 0 Wdraw2(1,1)];
lhdraw12 = kfh1([0 2]', Q2, F22, vart12, ys12,[0 prior_logh2(1)]',[zeros(1,2);0 prior_varh2(1,1)], 2);
 % Next draw state (chi square approximation mixture component) conditional on Sigtdraw
 % This is used to update at the next step the log-volatilities Sigtdraw
%
 for i = 1:T2
     for j = 1:numel(m_s)
            temp12= (1/sqrt(2*pi*u2_s(j)))*exp(-.5*(((yss12(i) - 2*lhdraw12(i) - m_s(j) + 1.2704)^2)/u2_s(j)));
            prw2(j,1) = q_s(j,1)*temp12;
     end
     prw2 = prw2./sum(prw2);
     cprw2 = cumsum(prw2);
     trand = rand(1,1);
     if trand < cprw2(1,1), imix2=1;
     elseif trand < cprw2(2,1), imix2=2;
     elseif trand < cprw2(3,1), imix2=3;
     elseif trand < cprw2(4,1), imix2=4;
     elseif trand < cprw2(5,1), imix2=5;
     elseif trand < cprw2(6,1), imix2=6;
     else imix2=7; 
     end
            % statedraw T+1 * N matrix
     statedraw2(i,1)=imix2;  % this is a draw of the mixture component index
end
tempH2= zeros(3, T2);
tempH2(1,:) = lhdraw12;

%%%%%%%%%%%%%%%%%%%%%%%%%%% (2) Draw h_2t's. %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for t=1:T2
   U232(:,t) = AA22(3,:,t)*(Y12(:,t) - X12(:,:,t)'*Bdraw2) ;
end
ystar22 = e2(:,2).^2;
yss22 = log(ystar22(:,1) + 0.001);
 
vart222 = zeros(T_HF*3,3); % vart2 := R
ys212 = zeros(T_HF*3,1);

for i = 1:T2
     imix2 = statedraw2(i,2);

     if i > Ti
         ii = i - Ti;
         vart222((ii-1)*3+1,1) = u2_s(imix1);
         vart222(3*(ii-1)+2,2) = Hdraw2(3,i)^2;  
         vart222(3*ii,3) = Sigma(ii);   
         ys212((ii-1)*3+1) = yss22(i) - m_s(imix1) + 1.2704;
         ys212((ii-1)*3+2) = U232(i);
         ys212(3*ii) = logRV(ii);
     end
end

% Draw oil price uncertainty.
RV_oilh_sb2;
tempH2(2,:) = lhdraw22;

for i = 1:T2
     for j = 1:numel(m_s)
            temp12= (1/sqrt(2*pi*u2_s(j)))*exp(-.5*(((yss22(i) - 2*lhdraw22(i) - m_s(j) + 1.2704)^2)/u2_s(j)));
            prw2(j,1) = q_s(j,1)*temp12;
     end
      prw2 = prw2./sum(prw2);
     cprw2 = cumsum(prw2);
     trand = rand(1,1);
     if trand < cprw2(1,1), imix2=1;
     elseif trand < cprw2(2,1), imix2=2;
     elseif trand < cprw2(3,1), imix2=3;
     elseif trand < cprw2(4,1), imix2=4;
     elseif trand < cprw2(5,1), imix2=5;
     elseif trand < cprw2(6,1), imix2=6;
     else imix2=7; 
     end
            % statedraw T+1 * N matrix
     statedraw2(i,2)=imix2;  % this is a draw of the mixture component index
end
%%%%%%%%%%%%%%%%%%%%%%%%%%% (3) Draw h_3t's. %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Next draw state (chi square approximation mixture component) conditional
% on h_1t and h2t. 

tempHH2 = genHH(tempH2', N, T2);
ystar32 = zeros(1,T2);
for t=1:T2
    ystar32(:,t) = (AA22(3,:,t)*(Y12(:,t) - X12(:,:,t)'*Bdraw2 -tempHH2(:,:,t)'*LL2))^2;
end
% Transform to the log-scale but also add the 'offset constant' 
 yss32 = log(ystar32' + 0.001);
 
 vart32 = zeros(T2,1);
 yss132 = zeros(T2,1);
    for i = 1:T2
            imix2 = statedraw2(i,3);
            vart32(i,:) = u2_s(imix2);
            yss132(i) = yss32(i) - m_s(imix1) + 1.2704;
    end

F22 = [1 0; int32 rho32];
Q2=[zeros(1,2); 0 Wdraw2(3,3)];
lhdraw32 = kfh1([0 2]', Q2, F22, vart32, yss132,[1 prior_logh2(3)]',[zeros(1,2);0 prior_varh2(3,3)], 2);
 
for i = 1:T2
    for j = 1:numel(m_s)
                temp12= (1/sqrt(2*pi*u2_s(j)))*exp(-.5*(((yss32(i) - 2*lhdraw32(i) - m_s(j) + 1.2704)^2)/u2_s(j)));
                prw2(j,1) = q_s(j,1)*temp12;
     end
    prw2 = prw2./sum(prw2);
     cprw2 = cumsum(prw2);
     trand = rand(1,1);
     if trand < cprw2(1,1), imix2=1;
     elseif trand < cprw2(2,1), imix2=2;
     elseif trand < cprw2(3,1), imix2=3;
     elseif trand < cprw2(4,1), imix2=4;
     elseif trand < cprw2(5,1), imix2=5;
     elseif trand < cprw2(6,1), imix2=6;
     else imix2=7; 
     end
    statedraw2(i,3)=imix2;  % this is a draw of the mixture component index
end
%%%%%%%%%%%%%%%%%%%%%% Put together the draws %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

lhdraw2 = [lhdraw12; lhdraw22; lhdraw32];
Hdraw2 = zeros(3,T2);
 for j = 1:N
     Hdraw2(j,:) = exp(lhdraw2(j,:));
 end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Draw W, the covariance of SIGMA(t) (from iWishart)
    % Get first differences of Sigtdraw to compute the SSE
    rd=repmat(rhodraw2',T2-1,1);
    intd=repmat(intdraw2',T2-1,1);
    Sigttemp = lhdraw2(:,2:end)' -intd - rd.*lhdraw2(:,1:end-1)';

    sse_2 = zeros(N,1);
    Wdraw2 = zeros(N,1);

    for ii=1:N
        %sse_2(ii) = Sigttemp(:,ii)'*Sigttemp(:,ii)+prior_QW(ii,ii);
        sse_2(ii) = Sigttemp(:,ii)'*Sigttemp(:,ii)+prior_QW2;
        %z = chol(inv(sse_2(ii)))'*randn(1,post_dfW);
        z = randn(post_dfW2,1);
        x = z'*z;
        Wdraw2(ii,ii) = sse_2(ii)/x;
    end
    
%%%%%%%%%%%  Draw F %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for ii=1:N
    Rxox2 = zeros(2,2);
    Rxoy2 = zeros(2,1);
    yh2 = lhdraw2(ii,2:end)'; 
    xh2 = [ones(T2-1,1) lhdraw2(ii,1:end-1)']; 
    for t = 1:T2-1
        Rxox2 = Rxox2 + xh2(t,:)'*inv(Wdraw2(ii,ii))*xh2(t,:);
        Rxoy2 = Rxoy2 + xh2(t,:)'*inv(Wdraw2(ii,ii))*yh2(t);
    end

    post_varrho2 = inv(inv(prior_varrho2)+Rxox2);
    post_meanrho2 = post_varrho2*(prior_varrho2\prior_meanrho2 + Rxoy2);

    intrho2(ii,:) = (post_meanrho2 + chol(post_varrho2)'*randn(2,1))';
end
intdraw2 = intrho2(:,1);
rhodraw2 = intrho2(:,2);
int12 = intdraw2(1);
int22 = intdraw2(2);
int32 = intdraw2(3);
rho12 = rhodraw2(1);
rho22 = rhodraw2(2);
rho32 = rhodraw2(3);

   