function [S1draw, S2draw] = drawS(post_dfS1, prior_QS1, post_dfS2, prior_QS2, A1draw, A2draw, T);
% This function first draws S1 and S2 - the variance of innovation of alpha
% from posterior IW distribution and then draws alphas by using Kalman
% filter.
% S1 and S2:
% Update scale matrices.
v1 = A1draw(:, 2:T) - A1draw(:, 1:T-1);
v2 = A2draw(:, 2:T) - A2draw(:, 1:T-1);
QS1temp=zeros(1,1);
QS2temp=zeros(2,2);
for i=1:T-1
    QS1temp = prior_QS1 + v1(i)*v1(i);
    QS2temp = prior_QS2 + v2(:,i)*v2(:,i)';
end

post_QS1 = chol(inv(QS1temp))';
post_QS2 = chol(inv(QS2temp))';
        
u1 = post_QS1*randn(1, post_dfS1);
S1draw = inv(u1*u1');
u2 = post_QS2*randn(2, post_dfS2);
S2draw = inv(u2*u2');
