% This code sets up the initial draws for the Gibbs sampler algorithm of the first subsample.

BLdraw1 = olsB1;
Bdraw1 = BLdraw1(1:end-1);
Ldraw1 = BLdraw1(end);
LL1 = zeros(N*N,1);
LL1(8,1) = Ldraw1;
A1draw11 = prior_meanA11(1)*ones(1,T1);
A2draw11 = [prior_meanA11(2)*ones(1,T1); prior_meanA11(3)*ones(1,T1)];
Hdraw1 = 0.1*ones(N, T1);
HH1=genHH(Hdraw1', N, T1);
consS = 0.001;
S1draw1 = consS*eye(1);
S2draw1 = consS*eye(2);
consW = 0.001;
Wdraw1 = consW*eye(N);
consQ = 0.001;
QBdraw1 = consQ * eye(N*(1+N*L));
Qdraw1 = consQ * eye(1);
for t=1:T1
     AA11(:,:,t) = genmatrixA(A1draw11(:,t), A2draw11(:,t), N);
     Hmtrx1(:,:,t) = diag(Hdraw1(:,t));
     UUtemp1(:,:,t) = inv(AA11(:,:,t))*Hmtrx1(:,:,t); % std. dev. of u's
     Udraw1(:,t) = diag(UUtemp1(:,:,t));
end
UU1 = HH1;
Omega1 = getOO(AA11, Hdraw1, T1, N);
ppdraw1 = eye(1);
mpdraw1 = ones(1,1);
Adraw11 = 0;
rhodraw1 = ones(N,1);
rho11 = rhodraw1(1);
rho21 = rhodraw1(2);
rho31 = rhodraw1(3);
intdraw1 = zeros(N,1);
int11 = intdraw1(1);
int21 = intdraw1(2);
int31 = intdraw1(3);
% parameters of the 7 component mixture approximation to a log(chi^2)
% density:
statedraw1 = 4*ones(T1+1,N); % initialize the draw of the indicator variable 
q_s = [0.00730; 0.10556; 0.00002; 0.04395; 0.34001; 0.24566; 0.25750];     % probabilities
m_s = [-10.12999; -3.97281; -8.56686; 2.77786; 0.61942; 1.79518; -1.08819];% means
u2_s = [5.79596; 2.61369; 5.17950; 0.16735; 0.64009; 0.34023; 1.26261];    % variances
prw1 = zeros(numel(q_s),1);

% set up the initial draws for the Gibbs sampler algorithm of the second subsample.

BLdraw2 = olsB2;
Bdraw2 = BLdraw2(1:end-1);
Ldraw2 = BLdraw2(end);
LL2 = zeros(N*N,1);
LL2(8,1) = Ldraw2;
A1draw22 = prior_meanA22(1)*ones(1,T2);
A2draw22 = [prior_meanA22(2)*ones(1,T2); prior_meanA22(3)*ones(1,T2)];
Hdraw2 = 0.1*ones(N, T2);
HH2=genHH(Hdraw2', N, T2);
consS = 0.001;
S1draw2 = consS*eye(1);
S2draw2 = consS*eye(2);
consW = 0.001;
Wdraw2 = consW*eye(N);
consQ = 0.001;
QBdraw2 = consQ * eye(N*(1+N*L));
Qdraw2 = consQ * eye(1);
for t=1:T2
     AA22(:,:,t) = genmatrixA(A1draw22(:,t), A2draw22(:,t), N);
     Hmtrx2(:,:,t) = diag(Hdraw2(:,t));
     UUtemp2(:,:,t) = inv(AA22(:,:,t))*Hmtrx2(:,:,t); % std. dev. of u's
     Udraw2(:,t) = diag(UUtemp2(:,:,t));
end
UU2 = HH2;
Omega2 = getOO(AA22, Hdraw2, T2, N);
ppdraw2 = eye(1);
mpdraw2 = ones(1,1);
Adraw2 = 0;
rhodraw2 = ones(N,1);
rho12 = rhodraw2(1);
rho22 = rhodraw2(2);
rho32 = rhodraw2(3);
intdraw2 = zeros(N,1);
int12 = intdraw2(1);
int22 = intdraw2(2);
int32 = intdraw2(3);
% parameters of the 7 component mixture approximation to a log(chi^2)
% density:
statedraw2 = 4*ones(T2+1,N); % initialize the draw of the indicator variable 
q_s = [0.00730; 0.10556; 0.00002; 0.04395; 0.34001; 0.24566; 0.25750];     % probabilities
m_s = [-10.12999; -3.97281; -8.56686; 2.77786; 0.61942; 1.79518; -1.08819];% means
u2_s = [5.79596; 2.61369; 5.17950; 0.16735; 0.64009; 0.34023; 1.26261];    % variances
prw2 = zeros(numel(q_s),1);

% allocate spaces for the posterior draws
postL1=zeros(1,NG);
postL2=zeros(1,NG);

