function bdraw = kfa(h, Q, F, r, y, btt0, vtt0, m)

% m : number of state variables
btt = btt0';
Vtt = vtt0;

[a b]=size(r);
T = a/b;
bt = zeros(T,m);
bp = zeros(T,m);
Vt = zeros(T*m,m);
Vp = zeros(T*m,m);

for i = 1:T
    bpt = F*btt;
    Vpt = F*Vtt*F'+Q;
    
    H = h(:,i);
    R = r((i-1)*b+1:i*b,:);
    cfe = y((i-1)*b+1:i*b) - H'*bpt;
    f = H'*Vpt*H+R;
    inv_f = inv(f);
    
    btt = bpt + Vpt*H*inv_f*cfe;
    Vtt = Vpt - Vpt*H*inv_f*H'*Vpt;
    
    bt(i,:) = btt'; % 1|1, 2|2, ....., T|T
    bp(i,:) = bpt'; % 1|0, 2|1, ..... T|T-1
    Vt(m*(i-1)+1:m*i,:) = Vtt; % 1|1, 2|2, ....., T|T
    Vp(m*(i-1)+1:m*i,:) = Vpt; % 1|0, 2|1, ..... T|T-1
end

bdraw = zeros(m,T);
bdraw(:,T) = bt(T,:)' + chol(Vt((T-1)*m+1:end,:))'*randn(m,1);

for i = 1:T-1
    bd = bdraw(:,T-i+1);
    bb = bt(T-i,:)' + Vt((T-i-1)*m+1:m*(T-i),:)*F'*inv(Vp((T-i)*m+1:(T-i+1)*m,:))*(bd-F*bt(T-i,:)');
    Vb = Vt((T-i-1)*m+1:m*(T-i),:) - Vt((T-i-1)*m+1:m*(T-i),:)*F'*inv(Vp((T-i)*m+1:(T-i+1)*m,:))*F*Vt((T-i-1)*m+1:m*(T-i),:);
    bdraw(:,T-i) = bb + chol(Vb)'*randn(m,1);
end
