function bdraw = kfh1(H, Q, F, r, y, btt0, vtt0, m)
% m : number of state variables
btt = btt0;
Vtt = vtt0;
[a b]=size(r);
T = a/b;
bt = zeros(T,m);
bp = zeros(T,m);
Vt = zeros(T*m,m);
Vp = zeros(T*m,m);

for i = 1:T
    bpt = F*btt;
    Vpt = F*Vtt*F'+Q;
    
    R = r((i-1)*b+1:i*b,:);
    cfe = y((i-1)*b+1:i*b) - H'*bpt;
    f = H'*Vpt*H+R;
    inv_f = inv(f);
    
    btt = bpt + Vpt*H*inv_f*cfe;
    Vtt = Vpt - Vpt*H*inv_f*H'*Vpt;
    
    bt(i,:) = btt';
    bp(i,:) = bpt';
    Vt(m*(i-1)+1:m*i,:) = Vtt;
    Vp(m*(i-1)+1:m*i,:) = Vpt;
end

bdraw = zeros(1,T);
bdraw(:,T) = bt(T,2)' + chol(Vt((T-1)*2+2:end,2))'*randn(1,1);

for i = 1:T-1
    b = bdraw(:,T-i+1);
    btemp = F*bt(T-i,:)';
    bb = bt(T-i,2)' + Vt((T-i-1)*m+2:m*(T-i),2)*F(2,2)'*inv(Vp((T-i)*m+2:(T-i+1)*m,2))*(b-btemp(2));
    Vb = Vt((T-i-1)*m+2:m*(T-i),2) - Vt((T-i-1)*m+2:m*(T-i),2)*F(2,2)'*inv(Vp((T-i)*m+2:(T-i+1)*2,2))*F(2,2)*Vt((T-i-1)*m+2:m*(T-i),2);
    bdraw(:,T-i) = bb + real(sqrtm(Vb))*randn(1,1);
end
