% This code sets up the initial draws for the Gibbs sampler algorithm.

BLdraw = olsB;
Bdraw = BLdraw(1:end-1);
Ldraw = BLdraw(end);
LL = zeros(N*N,1);
LL(8,1) = Ldraw;
A1draw = prior_meanA(1)*ones(1,T);
A2draw = [prior_meanA(2)*ones(1,T); prior_meanA(3)*ones(1,T)];
Hdraw = 0.1*ones(N, T);
HH=genHH(Hdraw', N, T);
consS = 0.001;
S1draw = consS*eye(1);
S2draw = consS*eye(2);
consW = 0.001;
Wdraw = consW*eye(N);
consQ = 0.001;
QBdraw = consQ * eye(N*(1+N*L));
Qdraw = consQ * eye(1);
for t=1:T
     AA(:,:,t) = genmatrixA(A1draw(:,t), A2draw(:,t), N);
     Hmtrx(:,:,t) = diag(Hdraw(:,t));
     UUtemp(:,:,t) = inv(AA(:,:,t))*Hmtrx(:,:,t); % std. dev. of u's
     Udraw(:,t) = diag(UUtemp(:,:,t));
end
UU = HH;
Omega = getOO(AA, Hdraw, T, N);
ppdraw = eye(1);
mpdraw = ones(1,1);
Adraw = 0;
rhodraw = ones(N,1);
rho1 = rhodraw(1);
rho2 = rhodraw(2);
rho3 = rhodraw(3);
intdraw = zeros(N,1);
int1 = intdraw(1);
int2 = intdraw(2);
int3 = intdraw(3);
% parameters of the 7 component mixture approximation to a log(chi^2)
% density:
statedraw = 4*ones(T+1,N); % initialize the draw of the indicator variable 
q_s = [0.00730; 0.10556; 0.00002; 0.04395; 0.34001; 0.24566; 0.25750];     % probabilities
m_s = [-10.12999; -3.97281; -8.56686; 2.77786; 0.61942; 1.79518; -1.08819];% means
u2_s = [5.79596; 2.61369; 5.17950; 0.16735; 0.64009; 0.34023; 1.26261];    % variances
prw = zeros(numel(q_s),1);

% allocate spaces for the posterior draws
postB=zeros(N*(1+N*L),NG);
postL=zeros(1,NG);
postD=zeros(1,NG);
postH = zeros(N, T, NG);
postA1 = zeros(NG,T);
postA2 = zeros(2,T, NG);
postPP = zeros(1, NG);
postAM = zeros(2, NG);
postAlpha = zeros(1,NG);

