%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This file contains the main VAR code for the paper "The effects of oil price 
% uncertainty on global real economic activity."  by Soojin Jo
% July 2013. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; close all; clc;
% add paths
%path(path,'C:\Jo2013\Code')
%path(path,'C:\Jo2013\Code\functions')
%path(path,'C:\Jo2013\Code\figures')
%path(path,'C:\Jo2013\Code\Data')
%path(path,'C:\Jo2013\Code\Appendix')
%path(path,'C:\Jo2013\Code\Variations')
path(path,'C:\Users\joso\Desktop\Jo2013')
path(path,'C:\Users\joso\Desktop\Jo2013\functions')
path(path,'C:\Users\joso\Desktop\Jo2013\figures')
path(path,'C:\Users\joso\Desktop\Jo2013\Data')
path(path,'C:\Users\joso\Desktop\Jo2013\Appendix')
path(path,'C:\Users\joso\Desktop\Jo2013\Variations')

genRV; % the function "genRV.m" generates realized volatility series 
% and its asymptotic variance using daily oil price data.

setup_benchmark;
initialdraws; % sets up initial draws
GS_benchmark; % runs the Gibbs sampler for the benchmark result.
% Summary statistics in Table 1 Column (1)
meanL = mean(postL) 
stdL = std(postL)
% create figures in the main text
figure1
figure2
figure4
figure5
IRFtoUncertainty
figure6
IRF1986
figure7
%% Results without realized volatility obtained from daily oil price changes
GS_woRV % runs the Gibbs sampler without realized volatility (i.e. without equation (7))
% Summary statistics in Table 1 Column (2)
meanLwoRV = mean(postLwoRV) 
stdLwoRV = std(postLwoRV)
figure3
%% Results with the data only from 1974Q2
setup_74;
initialdraws; 
GS_benchmark; 
% Summary statistics in Table 2 Column (1)
meanL74 = mean(postL) 
stdL74 = std(postL)
%% Results with Kilian's (2009) measure of economic activity
clear all; close all; clc;
genRV;
setup_K
initialdraws;
GS_benchmark;
% Summary statistics in Table 2 Column (2)
meanL = mean(postL) 
stdL = std(postL)
IRFtoUncertainty
% Generate Figure A1 in the Appendix
figure6
%% Results with US data
clear all; close all; clc;
genRV
setup_US
initialdraws;
GS_benchmark;
% Summary statistics in Table 2 Column (3)
meanL = mean(postL) 
stdL = std(postL)
